#import <Foundation/Foundation.h>
#import "XLDLibsndfileDecoder.h"

@implementation XLDLibsndfileDecoder
		

+ (BOOL)canHandleFile:(char *)path
{
	SF_INFO sfinfo_tmp;
	SNDFILE *sf_tmp = sf_open(path, SFM_READ, &sfinfo_tmp);
	if(sf_error(sf_tmp)) {
		//NSLog(@"%s",sf_strerror(sf_tmp));
		return NO;
	}
	sf_close(sf_tmp);
	return YES;
}

+ (BOOL)canLoadThisBundle
{
	if (floor(NSAppKitVersionNumber) <= 620 ) {
		return NO;
	}
	else return YES;
}

- (id)init
{
	[super init];
	sf = NULL;
	//trackArr = nil;
	//cueData = nil;
	error = NO;
	isFloat = 0;
	srcPath = nil;
	//metadataDic = [[NSMutableDictionary alloc] init];
	return self;
}

- (BOOL)openFile:(char *)path
{
	sf = sf_open(path, SFM_READ, &sfinfo);
	if(sf_error(sf)) {
		error = YES;
		return NO;
	}
	switch((sfinfo.format)&SF_FORMAT_SUBMASK) {
	  case 1:
		bps = 1;
		break;
	  case 2:
		bps = 2;
		break;
	  case 3:
		bps = 3;
		break;
	  case 4:
		bps = 4;
		break;
	  case 5:
		bps = 1;
		break;
	  case 6:
		isFloat = 1;
		bps = 4;
		break;
/*	  case 7:
		isFloat = 1;
		bps = 8;
		break;*/
	  default:
		sf_close(sf);
		sf = NULL;
		error = YES;
		return NO;
	}
	
	totalFrames = sfinfo.frames;
	
	if(!(((sfinfo.format)&SF_FORMAT_ENDMASK)^SF_ENDIAN_LITTLE) && !(((sfinfo.format)&SF_FORMAT_TYPEMASK)^SF_FORMAT_AIFF)) {
		int sample = sfinfo.frames > 16384 ? 16384 : sfinfo.frames;
		int *tmp = malloc(sample*4*sfinfo.channels);
		sf_readf_int(sf,tmp,sample);
		sf_seek(sf,0,SEEK_SET);
		free(tmp);
	}
	
	/*if(((sfinfo.format) & SF_FORMAT_TYPEMASK) == SF_FORMAT_FLAC) {
		FLAC__Metadata_SimpleIterator *it = FLAC__metadata_simple_iterator_new();
		if(FLAC__metadata_simple_iterator_init(it, path, true, true) != true) {
			FLAC__metadata_simple_iterator_delete(it);
			return YES;
		}
		while(1) {
			if(FLAC__metadata_simple_iterator_get_block_type(it) == FLAC__METADATA_TYPE_VORBIS_COMMENT) {
				FLAC__StreamMetadata *metadata = FLAC__metadata_simple_iterator_get_block(it);
				FLAC__StreamMetadata_VorbisComment comment = metadata->data.vorbis_comment;
				if(comment.num_comments < 1) goto metadata_read_last;
				int i;
				for(i=0;i<comment.num_comments;i++) {
					if(!strncasecmp((char *)comment.comments[i].entry,"cuesheet=",9)) {
						cueData = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+9 length:comment.comments[i].length-9] encoding:NSUTF8StringEncoding];
						if(cueData) [metadataDic setObject:cueData forKey:XLD_METADATA_CUESHEET];
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"title=",6)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+6 length:comment.comments[i].length-6] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_TITLE];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"artist=",7)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+7 length:comment.comments[i].length-7] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_ARTIST];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"album=",6)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+6 length:comment.comments[i].length-6] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_ALBUM];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"tracknumber=",12)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+12 length:comment.comments[i].length-12] encoding:NSUTF8StringEncoding];
						if(dat) {
							int track = [dat intValue];
							if(track > 0) [metadataDic setObject:[NSNumber numberWithInt:track] forKey:XLD_METADATA_TRACK];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"discnumber=",11)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+11 length:comment.comments[i].length-11] encoding:NSUTF8StringEncoding];
						if(dat) {
							int disc = [dat intValue];
							if(disc > 0) [metadataDic setObject:[NSNumber numberWithInt:disc] forKey:XLD_METADATA_DISC];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"genre=",6)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+6 length:comment.comments[i].length-6] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_GENRE];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"composer=",9)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+9 length:comment.comments[i].length-9] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_COMPOSER];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"date=",5)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+5 length:comment.comments[i].length-5] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_DATE];
							int year = [dat intValue];
							if(year >=1000 && year < 3000) [metadataDic setObject:[NSNumber numberWithInt:year] forKey:XLD_METADATA_YEAR];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"comment=",8)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+8 length:comment.comments[i].length-8] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_COMMENT];
							[dat release];
						}
					}
					else if(!strncasecmp((char *)comment.comments[i].entry,"ISRC=",5)) {
						NSString *dat = [[NSString alloc] initWithData:[NSData dataWithBytes:comment.comments[i].entry+8 length:comment.comments[i].length-8] encoding:NSUTF8StringEncoding];
						if(dat) {
							[metadataDic setObject:dat forKey:XLD_METADATA_ISRC];
							[dat release];
						}
					}
				}
			}
			else if(!trackArr && FLAC__metadata_simple_iterator_get_block_type(it) == FLAC__METADATA_TYPE_CUESHEET) {
				if(cueData) goto metadata_read_last;
				FLAC__StreamMetadata *metadata = FLAC__metadata_simple_iterator_get_block(it);
				FLAC__StreamMetadata_CueSheet cuesheet = metadata->data.cue_sheet;
				if(cuesheet.num_tracks < 1) goto metadata_read_last;
				int i;
				trackArr = [[NSMutableArray alloc] init];
				for(i=0;i<cuesheet.num_tracks;i++) {
					if(cuesheet.tracks[i].number == 170) continue;
					XLDTrack *track = [[objc_getClass("XLDTrack") alloc] init];
					[[track metadata] setObject:[NSNumber numberWithInt:i+1] forKey:XLD_METADATA_TRACK];
					[[track metadata] setObject:[NSNumber numberWithInt:cuesheet.num_tracks] forKey:XLD_METADATA_TOTALTRACKS];
					if(cuesheet.tracks[i].num_indices > 1) {
						[track setIndex:cuesheet.tracks[i].offset + cuesheet.tracks[i].indices[1].offset];
						[track setGap:cuesheet.tracks[i].indices[1].offset];
					}
					else [track setIndex:cuesheet.tracks[i].offset];
					if(i != 0) {
						if([track gap] != 0) [[trackArr objectAtIndex:i-1] setFrames:[track index] - [track gap] - [[trackArr objectAtIndex:i-1] index]];
						else [[trackArr objectAtIndex:i-1] setFrames:[track index] - [[trackArr objectAtIndex:i-1] index]];
					}
					[trackArr addObject:track];
					[track release];
				}
				if([trackArr count] < 1) {
					[trackArr release];
					trackArr = nil;
				}
				break;
			}
metadata_read_last:
			if(FLAC__metadata_simple_iterator_next(it) == false) break;
		}
metadata_read_end:
		FLAC__metadata_simple_iterator_delete(it);
	}*/
	if(srcPath) [srcPath release];
	srcPath = [[NSString alloc] initWithUTF8String:path];
	return YES;
}

- (void)dealloc
{
	if(sf) sf_close(sf);
	if(srcPath) [srcPath release];
	//if(trackArr) [trackArr release];
	//if(cueData) [cueData release];
	//[metadataDic release];
	[super dealloc];
}

- (int)samplerate
{
	return sfinfo.samplerate;
}

- (int)bytesPerSample
{
	return bps;
}

- (int)channels
{
	return sfinfo.channels;
}

- (xldoffset_t)totalFrames
{
	return totalFrames;
}

- (int)isFloat
{
	return isFloat;
}

- (int)decodeToBuffer:(int *)buffer frames:(int)count
{
	int ret;
	if(!isFloat) ret = sf_readf_int(sf,buffer,count);
	else ret = sf_readf_float(sf,(float *)buffer,count);
	if(sf_error(sf)) error = YES;
	return ret;
}

- (xldoffset_t)seekToFrame:(xldoffset_t)count
{
	xldoffset_t ret = sf_seek(sf,count,SEEK_SET);
	if(ret == -1 || sf_error(sf)) error = YES;
	return ret;
}

- (void)closeFile
{
	if(sf) sf_close(sf);
	sf = NULL;
	//if(trackArr) [trackArr release];
	//trackArr = nil;
	//if(cueData) [cueData release];
	//cueData = nil;
	//[metadataDic removeAllObjects];
	error = NO;
}

- (BOOL)error
{
	return error;
}

- (XLDEmbeddedCueSheetType)hasCueSheet
{
	return XLDNoCueSheet;
}

- (id)cueSheet
{
	return nil;
}

- (id)metadata
{
	return nil;
}

- (NSString *)srcPath
{
	return srcPath;
}

@end